import _construct from "@babel/runtime/helpers/esm/construct";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
var _excluded = ["React", "ReactDOM"],
    _excluded2 = ["style", "prefixCls", "language", "className", "editProps", "codePenOption", "codeSandboxOption", "code", "dependencies", "btnText", "btnHideText", "onlyEdit", "bordered", "noCode", "noPreview", "noScroll", "bgWhite"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React from 'react';
import ReactDOM from 'react-dom';
import CodeMirror from '@uiw/react-codemirror';
import copyTextToClipboard from '@uiw/copy-to-clipboard';
import Split from '@uiw/react-split';
import ThirdPartyButton from './ThirdPartyButton';
import * as icon from './icon';
import { BabelTransform } from './transform';
import './monokai.css';
import "./index.css";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var CodePreview = /*#__PURE__*/function (_React$PureComponent) {
  _inheritsLoose(CodePreview, _React$PureComponent);

  function CodePreview() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;
    _this.demoDom = /*#__PURE__*/React.createRef();
    _this.editor = /*#__PURE__*/React.createRef();
    _this.language = '';
    _this.initHeight = 3;
    _this.playerId = "" + parseInt(String(Math.random() * 1e9), 10).toString(36);
    _this.state = {
      errorMessage: '',
      fullScreen: false,
      copied: false,
      showEdit: false,
      width: 1
    };
    return _this;
  }

  var _proto = CodePreview.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var language = this.props.language;
    this.language = typeof language === 'string' ? language : language ? language.name || '' : '';

    if (!this.props.noPreview) {
      this.executeCode(this.props.code);
    }

    window.addEventListener("popstate", function (e) {
      document.body.style.overflow = 'inherit';
    }, false);
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var language = this.props.language;
    this.language = typeof language === 'string' ? language : language ? language.name || '' : '';

    if (prevProps.noPreview !== this.props.noPreview) {
      this.executeCode(this.props.code);
    }
  };

  _proto.executeCode = /*#__PURE__*/function () {
    var _executeCode = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(codeStr) {
      var _this$props$dependenc, dependencies, _React, _ReactDOM, otherDeps, deps, args, argv, key, input, _BabelTransform, code, message;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$props$dependenc = this.props.dependencies, dependencies = _this$props$dependenc === void 0 ? {} : _this$props$dependenc;
              _React = dependencies.React, _ReactDOM = dependencies.ReactDOM, otherDeps = _objectWithoutPropertiesLoose(dependencies, _excluded);

              if (/(jsx|js)/.test(this.language)) {
                _context.next = 4;
                break;
              }

              return _context.abrupt("return");

            case 4:
              try {
                deps = _extends({
                  context: this,
                  React: _React || React,
                  ReactDOM: _ReactDOM || ReactDOM
                }, otherDeps); // const args = ['context', 'React', 'ReactDOM', 'Component'];

                args = []; // const argv = [this, React, ReactDOM, Component];

                argv = [];

                for (key in deps) {
                  args.push(key);
                  argv.push(deps[key]);
                }

                codeStr = codeStr.replace('_mount_', "document.getElementById('" + this.playerId + "')");
                input = "" + codeStr;
                _BabelTransform = BabelTransform(input), code = _BabelTransform.code;
                args.push(code || ''); // eslint-disable-next-line no-new-func

                _construct(Function, args).apply(null, argv);

                this.setState({
                  errorMessage: ''
                });
              } catch (err) {
                message = '';

                if (err && err.message) {
                  message = err.message;
                } else {
                  message = JSON.stringify(err);
                }

                this.setState({
                  errorMessage: message
                });
              }

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function executeCode(_x) {
      return _executeCode.apply(this, arguments);
    }

    return executeCode;
  }()
  /**
   * onCopyCode
   */
  ;

  _proto.onCopyCode = function onCopyCode() {
    var _this2 = this;

    var code = this.props.code;
    copyTextToClipboard(code || '', function (isCopy) {
      _this2.setState({
        copied: isCopy
      });
    });
    setTimeout(function () {
      _this2.setState({
        copied: false
      });
    }, 2000);
  }
  /**
   * onFullScreen
   */
  ;

  _proto.onFullScreen = function onFullScreen() {
    var _this3 = this;

    var fullScreen = this.state.fullScreen;
    this.setState({
      fullScreen: !fullScreen
    }, function () {
      document.body.style.overflow = !fullScreen ? 'hidden' : 'inherit';

      if (!fullScreen && _this3.demoDom.current) {
        _this3.demoDom.current.style.maxWidth = 'inherit';
      }
    });
  };

  _proto.initOldHeight = function initOldHeight() {
    var demo = this.demoDom.current;

    if (this.initHeight === 3 && demo) {
      this.initHeight = demo.clientHeight;
    }
  }
  /**
   * onSwitchSource
   */
  ;

  _proto.onSwitchSource = function onSwitchSource() {
    var _this4 = this;

    var width = this.state.width;
    this.initOldHeight();
    this.setState({
      width: width === 1 ? '50%' : 1,
      showEdit: true
    }, function () {
      if (_this4.editor && _this4.editor.current && _this4.editor.current.editor) {
        _this4.editor.current.editor.setSize('100%', width !== 1 ? _this4.initHeight : '100%');
      }
    });
  };

  _proto.render = function render() {
    var _this5 = this;

    var _this$props = this.props,
        style = _this$props.style,
        prefixCls = _this$props.prefixCls,
        language = _this$props.language,
        className = _this$props.className,
        editProps = _this$props.editProps,
        codePenOption = _this$props.codePenOption,
        codeSandboxOption = _this$props.codeSandboxOption,
        code = _this$props.code,
        dependencies = _this$props.dependencies,
        btnText = _this$props.btnText,
        btnHideText = _this$props.btnHideText,
        onlyEdit = _this$props.onlyEdit,
        bordered = _this$props.bordered,
        noCode = _this$props.noCode,
        noPreview = _this$props.noPreview,
        noScroll = _this$props.noScroll,
        bgWhite = _this$props.bgWhite,
        otherProps = _objectWithoutPropertiesLoose(_this$props, _excluded2);

    var isOneItem = !noCode && !noPreview ? false : !noCode || !noPreview;
    var visiable = this.state.width === 1 ? false : [isOneItem ? 1 : 2];
    return /*#__PURE__*/_jsxs(Split, _extends({
      visiable: visiable,
      className: [className, prefixCls, noScroll ? prefixCls + "-noScroll" : null, isOneItem ? prefixCls + "-OneItem" : null, bordered ? prefixCls + "-bordered" : null, this.state.fullScreen ? prefixCls + "-fullScreen" : null].filter(Boolean).join(' ').trim(),
      style: _extends({
        flex: 1
      }, style)
    }, otherProps, {
      children: [!noPreview && !onlyEdit && /*#__PURE__*/_jsxs("div", {
        ref: this.demoDom,
        className: [prefixCls + "-demo", !bgWhite ? prefixCls + "-demo-bgPlaid" : null, this.state.errorMessage ? prefixCls + "-demo-error" : null].filter(Boolean).join(' ').trim(),
        style: _extends({
          flex: 1
        }, this.state.width === 1 ? {
          width: '100%'
        } : {}),
        children: [this.state.errorMessage && /*#__PURE__*/_jsx("pre", {
          children: /*#__PURE__*/_jsx("code", {
            children: this.state.errorMessage
          })
        }), /*#__PURE__*/_jsx("div", {
          className: [prefixCls + "-demo-source", this.state.errorMessage ? 'error' : null].filter(Boolean).join(' ').trim(),
          id: this.playerId
        })]
      }), (!noCode || onlyEdit) && /*#__PURE__*/_jsx("div", {
        style: {
          overflow: 'hidden',
          width: onlyEdit ? '100%' : this.state.width
        },
        children: (this.state.showEdit || onlyEdit) && /*#__PURE__*/_jsx(CodeMirror, _extends({
          value: (code || '').replace(/\n$/, ''),
          ref: this.editor,
          options: {
            theme: 'monokai',
            mode: language
          }
        }, editProps, {
          onChange: function onChange(editor, change) {
            _this5.executeCode(editor.getValue());

            if (editProps && editProps.onChange) {
              editProps.onChange(editor, change);
            }
          }
        }))
      }), !isOneItem && !(noCode && noPreview) && !onlyEdit && /*#__PURE__*/_jsxs("div", {
        style: {
          flex: 1,
          width: 29
        },
        className: prefixCls + "-bar",
        children: [/*#__PURE__*/_jsx(ThirdPartyButton, {
          prefixCls: prefixCls,
          codePenOption: codePenOption,
          codeSandboxOption: codeSandboxOption
        }), /*#__PURE__*/_jsx("div", {
          className: prefixCls + "-bar-btn",
          onClick: this.onSwitchSource.bind(this),
          children: this.state.width === 1 ? btnText : btnHideText
        }), /*#__PURE__*/_jsx("div", {
          className: [prefixCls + "-bar-iconbtns", this.state.copied ? prefixCls + "-bar-copied" : null].filter(Boolean).join(' ').trim(),
          onClick: this.onCopyCode.bind(this),
          children: icon.copy
        }), /*#__PURE__*/_jsx("div", {
          className: [prefixCls + "-bar-iconbtns", this.state.fullScreen ? prefixCls + "-bar-copied" : null].filter(Boolean).join(' ').trim(),
          onClick: this.onFullScreen.bind(this),
          children: icon.full
        })]
      })]
    }));
  };

  return CodePreview;
}(React.PureComponent);

CodePreview.defaultProps = {
  prefixCls: 'w-code-preview',
  language: 'jsx',
  code: '',
  btnText: 'Code',
  btnHideText: 'Hide Editor',
  editProps: {},
  dependencies: {},
  noCode: false,
  bgWhite: false,
  onlyEdit: false,
  noPreview: false,
  bordered: true
};
export { CodePreview as default };
//# sourceMappingURL=index.js.map